//chris busch
//replacement for slow floating pt


#include <stdlib.h>
//#include <math.h>
//#include <nan.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <iostream.h>

class Fastfloat
{
  // private:
public:
  int n;
public:
  enum {places=8,whatisone=(1<<places)};

  Fastfloat() {};
  Fastfloat(int a) { (*this)=a; }
  Fastfloat(double a) { (*this)=a; }
  Fastfloat(float a) { (*this)=a; }
  
  Fastfloat convert(int a)
    {
      Fastfloat dum;
      dum.n=a;
      return dum;
    }

  Fastfloat operator = (Fastfloat a)    {      return convert(n=a.n);    }
  Fastfloat operator = (int a)    {
      return convert(n=(a<<places));
    }
  Fastfloat operator = (double a)    {
	return convert(n=(int)(a*(1<<places)));
  }
  Fastfloat operator = (float a)    {
	return convert(n=(int)(a*(1<<places)));
  }
  Fastfloat operator + (Fastfloat a)    {      return convert(n+a.n);    }
  Fastfloat operator - (Fastfloat a)    {      return convert(n-a.n);    }
  Fastfloat operator * (Fastfloat a)
    {
      return 
/*		convert( 
				((unsigned int)(abs(n)*(unsigned int)abs(a.n))>>places) 
				*  (1 - ( ((n<0)^(a.n<0)) << 1)));
*/
		convert( 
				((unsigned int)(n*(unsigned int)a.n)/whatisone)) ;
//				*  (1 - ( ((n<0)^(a.n<0)) << 1)));
	  //		* (((n<0)!=(a.n<0)) ? -1 : 1));
    }
  Fastfloat operator / (Fastfloat a)
    {
      return convert(
					 (unsigned int)(n*whatisone)/a.n); 
//					 (unsigned int)(abs(n)<<places)/abs(a.n) 
//					 *  (1 - ( ((n<0)^(a.n<0)) << 1)));
	  //		     *   (((n<0)!=(a.n<0)) ? -1 : 1));
    }
  operator int()    {      return n>>places;    }
  operator float()    {      return n/(float)(1<<places);    }
  operator double()    {      return n/(double)(1<<places);    }

  int operator == (Fastfloat a)    {      return n == a.n;    }
  int operator != (Fastfloat a)    {      return n != a.n;    }
  int operator > (Fastfloat a)    {      return n > a.n;    }
  int operator < (Fastfloat a)    {      return n < a.n;    }
  int operator >= (Fastfloat a)    {      return n >= a.n;    }
  int operator <= (Fastfloat a)    {      return n <= a.n;    }
};


#include <iostream.h>

float bb()
{
  return 3.0;
}

void main()
{
  Fastfloat a,b;
  float A,B,C,c,d;
  int dummy;
  
  a=2,b=3;
  A=2.0;B=3.0;
/*  
  time_t start;
  int i;

  cout <<"start\n";
  start=time(NULL);
  for(i=0;i<100000;i++) C=A/bb();
  cout << "stop " << time(NULL)-start << "\n";

  cout <<"start\n";
  start=time(NULL);
  for(i=0;i<100000;i++) c=a/b;
  cout << "stop " << time(NULL)-start << "\n";



}*/

#ifdef NAN
  cout << "nanny\n";
#endif


  while( cin.good())
    {
      if(!fork())
	{
	  cout << "\nenter two numbers: ";
	  cin >> c >> d;
	  a=c;
	  b=d;
	  cout << "\n a=" << hex << a.n << " b=" << b.n << "\n" << dec;
	  cout << "\n a + b " << float( a + b);
	  cout << "\n a - b " << float( a - b);
	  cout << "\n a * b " << float( a * b) << flush;
	  cout << "\n a / b " << float( a / b);
	  cout << "\n a < b " << float( a < b);
	  cout << "\n a > b " << float( a > b);
	  cout << "\n a == b " << float( a == b);
	  exit(0);
	}
      wait(&dummy);
    }
}




