/*
Chris Busch
*/


#ifndef NET_H
#define NET_H

#include "prob.h"
#include "pelement.h"


class net
{
public:
	enum {maxlayers=3,maxpewidth=5}; 
	enum {inputlayer=0,outputlayer=maxlayers-1}; 
private:
	pelement pes[maxlayers][maxpewidth];
	int getptrs[maxlayers];
	int putinptr,getoutptr;	

public:

	net();
	~net();
	
	void clear();
	void createlinks(prob=0);

	void dump();

	
	void putinreset() { putinptr=0; }
	net& operator-() { putinreset(); return *this; }
	prob putin(prob);
	net& operator<<(prob p) { putin(p); return *this; } 
	// ^^^potentially not useful since you lose return value
	//mmm, could have p=putin(p).... 

	void getoutreset() { getoutptr=0; }
	net& operator+() { getoutreset(); return *this; }
	prob getout();
	net& operator>>(prob& p) { p=getout(); return *this; }

	cgbbool getreset(int);
	pelement* get(int);
	
	void copy(net&);

	void run();

	//backprop stuff:
	
/*
	prob A(int i,int j,int lyr) //layer-1 implied
	{ return pes[lyr][i].inputs.nthin(j); }
	prob A(int i) 
	{ return pes[outputlayer][i].getoutput(); }
	
	int numinputs() { return maxpewidth; } //number of inputs
	prob itrate() { return 72.0/numinputs(); } //
	prob errsig(int i,int L)
	{
		if(L==outputlayer) return T(i)-A(i);
		prob s=0;
		for(int n=0;n<maxpewidth;n++) //hack hope it works
		{
			s+= (T(n)-A(n))* pes[outputlayer][n].inputs.nthwate(i);
		}
		s/=maxpewidth;
		return s;
	}
		
			
*/
};
	


#endif 
//end of this file





